--------------------------------------------------------------------------
--------------------------------------------------------------------------
---  circuito tb
--------------------------------------------------------------------------
--------------------------------------------------------------------------
library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Std_Logic_unsigned.all;   -- uso conv_integer
use IEEE.Std_Logic_arith.all;
 
entity tb is
 end tb;
        

architecture tb of tb is
                                      
   signal ck, reset : std_logic;
   signal halt : std_logic; -- added by Ney to conform to Cleo interfaces signals
   signal input1, input2, output1, output2, output3 : std_logic_vector(7 downto 0);	 
		-- added by Ney to generalize input/output interfaces for Cleo

begin


   UUT : entity work.top port map
	   ( ck=>ck, reset=>reset, halt=>halt,
	   input1=>input1, input2=>input2,
	   output1=>output1,  output2=>output2, output3=>output3
	   );
  
   reset <= '1', '0' after 5 ns;
         
   process
            begin
             ck <= '1', '0' after 10 ns;
             wait for 20 ns;
   end process;
   -- Ney: clock frequency changed to conform exactly to implementation, 50MHz
   
   input1 <= x"00";
   input2 <= x"01", x"00" after 650us;
   
               
end tb;
