--########################################################################
--
--  Este arquivo contm as seguintes entidades :
--      ==> Decodificador para acesso  entrada/sada ou memria
--      ==> Memria na forma de um vetor, com o cdigo objeto em um package
--
--   FERNANDO GEHM MORAES	03/agosto/2005
--   NEY LAERT VILAR CALAZANS	27/junho/2006
--
--########################################################################

--########################################################################
--
-- Decodificador para acesso  entrada/sada ou memria
--
-- Ney (27/06/2006): generalizao das entradas e sadas. Agora sero
-- at 4 sadas de 8 bits e 4 entradas de 8 bits. Limitaes e detalhes
-- no mdulo top.
-- Ney (18/06/2006): acrscimo de uma posio de memria para E/S,
-- 	disponibilizando a possibilidade de separao de entrada de dados
-- 	e entrada de sinais de controle (botes BTN1 a BTN5)
--########################################################################
library IEEE;
use IEEE.Std_Logic_1164.all;

entity es_decoder is
    port(ce, rw:  in std_logic;
         address: in std_logic_vector(7 downto 0);
         ceCPU, rwCPU, ceES, rwES: out std_logic);
end es_decoder;

architecture a1 of es_decoder is

  signal add_es  : std_logic;
  
begin
  
    -- 
    -- acessos aos endereos FC a FF designam acesso  entrada e sada
    --
    add_es <=	'1' when address > x"FB" else
		'0';
                
    ceCPU <=	'1' when ce='1' and add_es='0'  else '0';
    ceES  <=	'1' when ce='1' and add_es='1'  else '0';
    
    
    rwCPU <=	'1' when rw='1' and add_es='0'  else '0';
    rwES  <=	'1' when rw='1' and add_es='1'  else '0';
   
     
end a1;

--########################################################################
--
-- memria na forma de um vetor - cdigo objeto definido em package
--
--########################################################################
library IEEE;
use ieee.STD_LOGIC_UNSIGNED.all;
use ieee.std_logic_1164.all;
use work.object_code.all;                  -- cdigo objeto definido neste package

entity RAM_mem is
      port( clock, ce, rw : in  std_logic;
            address:  in  std_logic_vector(7 downto 0);
            datain:   in  std_logic_vector(7 downto 0);
            dataout:  out std_logic_vector(7 downto 0) );
end RAM_mem;

architecture RAM_mem of RAM_mem is 
begin    

   process(clock)
   begin
       if clock'event and clock='1' then
          if ce='1' and rw='0' then               
                  memoria(CONV_INTEGER(address)) <= datain;       -- writes in memory
          end if;  
          
          dataout <=  memoria(CONV_INTEGER(address)) ;              -- memory reading
          
       end if;
   end process;    
   
end RAM_mem;
                                                                                         